// Leds Voicemeter v1.0 by Seleznev D.L. / Hidden Codes 2004

#include "stdafx.h"

#define APP_NAME	"Leds VoiceMeter"
#define APP_VERSION	"v1.0"
#define APP_COPY	" 2004 Seleznev D.L."
#define APP_ADR		"mailto:hcodes@narod.ru\nwww.hcodes.narod.ru"

#define BUF_LEN		1024
#define TIMER_INTERVAL	100
#define LEVEL1		30
#define LEVEL2		80
#define LEVEL3		210
	
HANDLE hndKbdDev;
char szAppName[] = APP_NAME;
BYTE keyState[256];

bool bDownNumLock;
bool bDownScrollLock;
bool bDownCapsLock;
bool bRestoreLeds = true;
bool bNT = true;

winampVisModule *getModule(int which);
void config(struct winampVisModule *this_mod);
int init(struct winampVisModule *this_mod);
int render1(struct winampVisModule *this_mod);
void quit(struct winampVisModule *this_mod);
void switch_leds_nt(USHORT usLedFlags);
void my_memset(void* output, int value, int len);
void stop_leds(bool bNew);
void pause_leds();
int my_len(char* output);
bool my_cmp(char* string1, char* string2);
void my_copy(char* string1, char* string2);
long my_hash(char* cString);

//------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{
	return true;
}
//------------------------------------------------------------------
void init_leds()
{
	if (bNT)
	{
		DefineDosDevice(DDD_RAW_TARGET_PATH, "Kbd_spec", "\\Device\\KeyboardClass0");
		hndKbdDev = CreateFile("\\\\.\\Kbd_spec", GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
		if (hndKbdDev == INVALID_HANDLE_VALUE) hndKbdDev = 0;
	}
	else
	{
		GetKeyboardState((LPBYTE)&keyState);
	}
}
//------------------------------------------------------------------
void done_leds()
{
	if (bNT && hndKbdDev) 
	{
		DefineDosDevice(DDD_REMOVE_DEFINITION, "Kbd_spec", 0);
		CloseHandle(hndKbdDev); hndKbdDev = 0;
	}

}
//------------------------------------------------------------------
// our window procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
HWND hMainWnd;

winampVisHeader hdr = { VIS_HDRVER, APP_NAME " " APP_VERSION, getModule };
winampVisModule mod1 =
{
	APP_NAME " " APP_VERSION,
	NULL,	// hwndParent
	NULL,	// hDllInstance
	0,		// sRate
	0,		// nCh
	50,		// latencyMS
	50,		// delayMS
	1,		// spectrumNch
	0,		// waveformNch
	{ 0, },	// spectrumData
	{ 0, },	// waveformData
	config,
	init,
	render1, 
	quit
};

#ifdef __cplusplus
extern "C" {
#endif
__declspec( dllexport ) winampVisHeader *winampVisGetHeader()
{
	return &hdr;
}
#ifdef __cplusplus
}
#endif

//------------------------------------------------------------------
winampVisModule *getModule(int which)
{
	switch (which)
	{
		case 0: 
			return &mod1;
		default:
			return NULL;
	}
}
//------------------------------------------------------------------
LRESULT CALLBACK DLGPROC_Config(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
//------------------------------------------------------------------
void config(struct winampVisModule *this_mod)
{

	MessageBox(this_mod->hwndParent, APP_NAME " " APP_VERSION "\n\n"
		APP_COPY "\n\n" APP_ADR "\n\n", "About Plugin", MB_OK);
}
//------------------------------------------------------------------
int init(struct winampVisModule *this_mod)
{
	DWORD dwVersion = GetVersion();
	if (dwVersion < 0x80000000)	bNT = true; 

	init_leds();

		WNDCLASS wc;
		my_memset(&wc, 0,  sizeof(wc));
		wc.lpfnWndProc = WndProc;
		wc.hInstance = this_mod->hDllInstance;
		wc.lpszClassName = szAppName;

	if (!RegisterClass(&wc)) 
	{
		MessageBox(this_mod->hwndParent, 
			"Error registering window class",
			"Error",
			MB_OK);

		return 1;
	}
	
	hMainWnd = CreateWindow(
				szAppName,
				this_mod->description,
				NULL,
				0, 0, 
				10, 10,
				this_mod->hwndParent,
				NULL,
				this_mod->hDllInstance,
				0);
	if (!hMainWnd) 
	{
		MessageBox(this_mod->hwndParent,
			"Error creating window",
			"Error",
			MB_OK);

		return 1;
	}

	return 0;
}
//------------------------------------------------------------------
int render1(struct winampVisModule *this_mod)
{

	if (bNT)
	{
		USHORT usLedFlags=0;
		if (this_mod->spectrumData[0][0]>LEVEL1) usLedFlags |= KEYBOARD_NUM_LOCK_ON;
		if (this_mod->spectrumData[0][0]>LEVEL2) usLedFlags |= KEYBOARD_CAPS_LOCK_ON;
		if (this_mod->spectrumData[0][0]>LEVEL3) usLedFlags |= KEYBOARD_SCROLL_LOCK_ON;
		switch_leds_nt(usLedFlags);
	}

	return 0;
}
//---------------------------------------------------------------------------------
void quit(struct winampVisModule *this_mod)
{
	USHORT usLedFlags = 0;

	if (bRestoreLeds)
	{
		bDownNumLock = GetKeyState(VK_NUMLOCK);
		bDownCapsLock = GetKeyState(VK_CAPITAL);
		bDownScrollLock = GetKeyState(VK_SCROLL);
		if (bNT)
		{
			if (bDownNumLock) usLedFlags |= KEYBOARD_NUM_LOCK_ON;
			if (bDownCapsLock) usLedFlags |= KEYBOARD_CAPS_LOCK_ON;
			if (bDownScrollLock) usLedFlags |= KEYBOARD_SCROLL_LOCK_ON;
			switch_leds_nt(usLedFlags);
		}
	}
	done_leds();
	DestroyWindow(hMainWnd);
	UnregisterClass(szAppName,this_mod->hDllInstance);
}
//----------------------------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_CREATE:
			return 0;
		case WM_DESTROY:
			PostQuitMessage(0); return 0;
	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}
//------------------------------------------------------------------
void switch_leds_nt(USHORT usLedFlags)
{
	DWORD xx;
	unsigned prev_keyled = -1;
	KEYBOARD_INDICATOR_PARAMETERS InputBuffer;

	InputBuffer.LedFlags = InputBuffer.UnitId = 0;
	InputBuffer.LedFlags = usLedFlags;
	
	if (prev_keyled != InputBuffer.LedFlags)
	{
		prev_keyled = InputBuffer.LedFlags,
		DeviceIoControl(hndKbdDev, CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0002, METHOD_BUFFERED, FILE_ANY_ACCESS),
			&InputBuffer, sizeof(KEYBOARD_INDICATOR_PARAMETERS), 0, 0, &xx, 0);
	}
}
//------------------------------------------------------------------
void my_memset(void* output, int iValue, int iLen)
{
	if (iLen)
	{
		do
		{
			*(unsigned char*)output = (unsigned char)iValue;
			output = (void*)((unsigned int)output + 1);
		}
		while(--iLen != 0);
	}
}
//-----------------------------------------------------------------
int my_len(char* cOutput)
{
	char* cBuf=cOutput;
	while (*cOutput)
	{
		cOutput++;
	}
	return (cOutput-cBuf);
}
//-----------------------------------------------------------------
bool my_cmp(char* string1, char* string2)
{
	if (my_len(string1)!=my_len(string2))	return false;
	while (*string1)
	{
		if (*string1!=*string2)	return false;

		string1++;
		string2++;

	}

	return true;
}
//-----------------------------------------------------------------
void my_copy(char* string1, char* string2)
{
	while (*string2)
	{
		*(string1)=*(string2);

		string1++;
		string2++;
	}
	*string1=0;
}
//-----------------------------------------------------------------
long my_hash(char* cString)
{
	long hash=0;
	for (int i=0; i<my_len(cString); i++)
	{
		hash+=cString[i]*i;
	}

return hash;
}
//-----------------------------------------------------------------