// Window Text Voicemeter v1.01 by Seleznev D.L. / Hidden Codes 2004

#include "stdafx.h"

#define APP_NAME	"Window Text VoiceMeter"
#define APP_VERSION	"v1.01"
#define APP_COPY	" 2004 Seleznev D.L."
#define APP_ADR		"mailto:hcodes@narod.ru\nwww.hcodes.narod.ru"

#define BUF_LEN		1024
#define TIMER_INTERVAL	100
	
char szAppName[] = APP_NAME;

winampVisModule *getModule(int which);
void config(struct winampVisModule *this_mod);
int init(struct winampVisModule *this_mod);
int render1(struct winampVisModule *this_mod);
void quit(struct winampVisModule *this_mod);
void my_memset(void* output, int value, int len);
int my_len(char* output);
bool my_cmp(char* string1, char* string2);
void my_copy(char* string1, char* string2);
long my_hash(char* cString);

//------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{
	return true;
}
//------------------------------------------------------------------
// our window procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
HWND hMainWnd;

winampVisHeader hdr = { VIS_HDRVER, APP_NAME " " APP_VERSION, getModule };
winampVisModule mod1 =
{
	APP_NAME " " APP_VERSION,
	NULL,	// hwndParent
	NULL,	// hDllInstance
	0,		// sRate
	0,		// nCh
	50,		// latencyMS
	50,		// delayMS
	1,		// spectrumNch
	0,		// waveformNch
	{ 0, },	// spectrumData
	{ 0, },	// waveformData
	config,
	init,
	render1, 
	quit
};

#ifdef __cplusplus
extern "C" {
#endif
__declspec( dllexport ) winampVisHeader *winampVisGetHeader()
{
	return &hdr;
}
#ifdef __cplusplus
}
#endif

//------------------------------------------------------------------
winampVisModule *getModule(int which)
{
	switch (which)
	{
		case 0: 
			return &mod1;
		default:
			return NULL;
	}
}
//------------------------------------------------------------------
LRESULT CALLBACK DLGPROC_Config(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
//------------------------------------------------------------------
void config(struct winampVisModule *this_mod)
{
	MessageBox(this_mod->hwndParent, APP_NAME " " APP_VERSION "\n\n"
		APP_COPY "\n\n" APP_ADR "\n\n", "About Plugin", MB_OK);
}
//------------------------------------------------------------------
int init(struct winampVisModule *this_mod)
{
		WNDCLASS wc;
		my_memset(&wc, 0,  sizeof(wc));
		wc.lpfnWndProc = WndProc;
		wc.hInstance = this_mod->hDllInstance;
		wc.lpszClassName = szAppName;

	if (!RegisterClass(&wc)) 
	{
		MessageBox(this_mod->hwndParent, "Error registering window class",
			"Error", MB_OK);

		return 1;
	}
	
	hMainWnd = CreateWindow(
				szAppName,
				this_mod->description,
				NULL,
				0, 0, 
				10, 10,
				this_mod->hwndParent,
				NULL,
				this_mod->hDllInstance,
				0);
	if (!hMainWnd) 
	{
		MessageBox(this_mod->hwndParent, "Error creating window",
			"Error", MB_OK);

		return 1;
	}

	return 0;
}
//------------------------------------------------------------------
int render1(struct winampVisModule *this_mod)
{
	static char cWinTextLast[BUF_LEN]={0};
	static char cWinText[BUF_LEN]={0};
	static char cWinTextMain[BUF_LEN]={0};
	static HWND hWinLast=NULL;
	static long lHashLast=0;
	static int	iTimer=0;

	long lHash=my_hash(this_mod->description);
	if (lHash!=lHashLast)
	{
		iTimer=0;
	}
	lHashLast=lHash;
	HWND hWin=GetForegroundWindow();
	int iLen=0;

	if (hWinLast && hWinLast!=hWin && hWinLast!=this_mod->hwndParent)
	{
		SendMessage(hWinLast, WM_SETTEXT, 0, (LPARAM) cWinTextMain);
	}

	if (!hWin || hWin==this_mod->hwndParent)	return 0;

	if (hWin!=hWinLast)	iLen=SendMessage(hWin, WM_GETTEXT, BUF_LEN, (LPARAM) cWinTextMain);
		
	int iSD=this_mod->spectrumData[0][0]/32;

	my_copy(cWinText, cWinTextMain);
	int i=my_len(cWinText);
	cWinText[i]=' ';
	if (iTimer<TIMER_INTERVAL)
	{
		my_copy(&cWinText[i+1], this_mod->description);
		iTimer++;
	}
	else
	{
		my_memset(&cWinText[i+1], '>', iSD);
		cWinText[i+1+iSD]=0;
	}

	SendMessage(hWin, WM_SETTEXT, 0, (LPARAM) cWinText);

	hWinLast=hWin;
	return 0;
}
//---------------------------------------------------------------------------------
void quit(struct winampVisModule *this_mod)
{
	DestroyWindow(hMainWnd);
	UnregisterClass(szAppName,this_mod->hDllInstance);
}
//----------------------------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_CREATE:		return 0;
		case WM_DESTROY:	PostQuitMessage(0); return 0;
	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}
//------------------------------------------------------------------
void my_memset(void* output, int iValue, int iLen)
{
	if (iLen)
	{
		do
		{
			*(unsigned char*)output = (unsigned char)iValue;
			output = (void*)((unsigned int)output + 1);
		}
		while(--iLen != 0);
	}
}
//-----------------------------------------------------------------
int my_len(char* cOutput)
{
	char* cBuf=cOutput;
	while (*cOutput)
	{
		cOutput++;
	}

	return (cOutput-cBuf);
}
//-----------------------------------------------------------------
bool my_cmp(char* string1, char* string2)
{
	if (my_len(string1)!=my_len(string2))	return false;
	while (*string1)
	{
		if (*string1!=*string2)	return false;
		string1++;
		string2++;
	}
	return true;
}
//-----------------------------------------------------------------
void my_copy(char* string1, char* string2)
{
	while (*string2)
	{
		*(string1)=*(string2);
		string1++;
		string2++;
	}
		*string1=0;

	return;
}
//-----------------------------------------------------------------
long my_hash(char* cString)
{
	long hash=0;
	for (int i=0; i<my_len(cString); i++)
	{
		hash+=cString[i]*i;
	}

	return hash;
}